# Feature Extractor

Feature extractor extracts general MIP features from problem instances.
This feature extractor was used to produce the raw feature data
for the instance selection of MIPLIB 2017.

The usage is as follows
```
feature-extractor -p <filename> [-s <settings>]
```

where `filename` is the path to a MIP in a format that SCIP accepts.
This will print out a comma separated feature vector
after SCIP presolved the instance.
Optionally, settings can be passed to SCIP to influence
the SCIP presolving.
In order to to deactivate presolving, a settings file
that deactivates presolving must be passed.

In order to access the header containing the feature names,
run the "feature-header-names" executable.

### Project structure
* ``` / ``` - Scripts for building and running feature extractor and this file
* ``` /src ``` - C++ source files for feature calculation
* ``` /src_py ``` - Python source files for merging generated feature files

### Compiling the Project

The feature extractor requires SCIP (Version 5.0 or higher) installed or built with CMake.
It also uses Boost for the command line options. If both packages are present in the
system, create a 'build' directory, navigate there, and configure the build using cmake before compiling:

```
mkdir build
cd build
cmake .. [-DCMAKE_PREFIX_PATH=/path/to/scip/]
make
```

The specification of a `CMAKE_PREFIX_PATH` is only necessary, if SCIP has been installed in a nonstandard location,
or if a SCIP build directory is specified, which developers sometimes need.

Note that in order to debug later, it is recommended to build SCIP in Debug mode, using `-DCMAKE_BUILD_TYPE=Debug`.